<?php
class ControllerPaymenteasypay extends Controller {
	protected function index() {
		$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');
						
		if ($this->request->get['route'] != 'checkout/guest_step_3') {
			$this->data['cancel_return'] = HTTPS_SERVER . 'index.php?route=checkout/payment';
		} else {	
			$this->data['cancel_return'] = HTTPS_SERVER . 'index.php?route=checkout/guest_step_2';
		}
		
		if ($this->request->get['route'] != 'checkout/guest_step_3') {
			$this->data['back'] = HTTPS_SERVER . 'index.php?route=checkout/payment';
		} else {
			$this->data['back'] = HTTPS_SERVER . 'index.php?route=checkout/guest_step_2';
		}

		$this->id = 'payment';
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/easypay.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/easypay.tpl';
		} else {
			$this->template = 'default/template/payment/easypay.tpl';
		}
		$this->render();
		
	}

	# нажатие кнопки "<< Назад в магазин" 
	public function fail() {
		$this->load->model('checkout/order');
		$this->model_checkout_order->confirm((int)$this->request->get['EP_OrderNo'], 7);
		$this->redirect(HTTPS_SERVER . 'index.php?route=checkout/cart');	
		return TRUE;
	}

	# перенаправление клиента после оплаты
	public function success() {
		$this->load->model('checkout/order');
		$this->model_checkout_order->confirm((int)$this->request->get['EP_OrderNo'], 1);
		$this->redirect(HTTPS_SERVER . 'index.php?route=checkout/success');
		$this->data['continue'] = HTTPS_SERVER . 'index.php?route=checkout/success';
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
		return TRUE;		
	}
		
	#уведомление об оплате
	public function notify() {
		$order_mer_code = $this->request->post['order_mer_code'];
		$sum            = $this->request->post['sum'];
		$mer_no         = $this->request->post['mer_no'];
		$card           = $this->request->post['card'];
		$purch_date     = $this->request->post['purch_date'];
		$web_key        = $this->config->get('webkey');
		$notify_sig     = $this->request->post['notify_signature'];

		$sig = md5 ($order_mer_code . $sum . $mer_no . $card . $purch_date . $web_key);
		if ($notify_sig == $sig) {
			$this->load->model('checkout/order');
			$this->model_checkout_order->update($order_mer_code, $this->config->get('processing_status_id'));
			header("HTTP/1.0 200 OK"); // генерация HTTP-заголовка
		}else{
			header("HTTP/1.0 400 Bad Request");
		}
	}
	public function redir() {

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$this->data['action'] = 'https://ssl.easypay.by/weborder/?EP_Module=opencart_1_4';
		
		#установка переменных, заголовки берутся из локализационных файлов
		$this->data['merchant']    = $this->config->get('merchant');  
		$this->data['order_id']    = $this->session->data['order_id'];
		$this->data['description'] = html_entity_decode($this->config->get('config_store'), ENT_QUOTES, 'UTF-8');
		$this->data['debug']       = $this->config->get('debug');
		$this->data['expires']     = $this->config->get('expires');
		$this->data['hash']        = md5($this->config->get('merchant') . $this->config->get('webkey') . $this->session->data['order_id'] . $order_info['total']);

		$this->data['amount'] = $order_info['total'];
		$this->data['return'] = HTTPS_SERVER . 'index.php?route=payment/easypay/success';
		$this->data['fail']   = HTTPS_SERVER . 'index.php?route=payment/easypay/fail';
		
		$this->model_checkout_order->confirm($this->session->data['order_id'], $this->config->get('pending_status_id'));
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/easypay_send.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/easypay_send.tpl';
		} else {
			$this->template = 'default/template/payment/easypay_send.tpl';
		}
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_template'));
	}
}
?>